Index: /trunk/ChangeLog
===================================================================
--- /trunk/ChangeLog	(revision 573)
+++ /trunk/ChangeLog	(revision 574)
@@ -1,11 +1,19 @@
 2.4.X 
-  * Allow regular expressions for recipient_list (multiple to-addresses), white_list 
-    and black_list. Each address is checked againt this regular expression, closes #272
+  * Allow regular expressions for recipient_list (multiple to-addresses), 
+    white_list and black_list. Each address is checked againt this regular 
+    expression, closes #272
     examples:
      * recipient_list : sara.nl (to-address contains sara.nl)
      * recipient_list : ^basv@sara.nl$ (to-address equals basv@sara.nl)
-  Reported by: anonymous
-  Fixed by: Bas van der Vlies
-
+    Reported by: anonymous
+    Fixed by: Bas van der Vlies
+
+
+  * Enhanced run_email2trac to support supplementary groups (initgroups). 
+    configure will check if the OS support initgroups function call,
+    closes #274
+    Author: Dennis McRitchie <dmcr add Princeton dot EDU >
+    Applied by: Bas van der Vlies
+ 
 2.4.2 
   * Fixed an error for text/plain attachments that are not specified as 
Index: /trunk/config.h.in
===================================================================
--- /trunk/config.h.in	(revision 574)
+++ /trunk/config.h.in	(revision 574)
@@ -0,0 +1,2 @@
+/* Define to 1 if you have the `initgroups' function. */
+#undef HAVE_INITGROUPS
Index: /trunk/configure.in
===================================================================
--- /trunk/configure.in	(revision 573)
+++ /trunk/configure.in	(revision 574)
@@ -7,4 +7,5 @@
 #
 AC_INIT(email2trac.py.in)
+AC_CONFIG_HEADER(config.h)
 AC_SUBST(prefix)
 AC_SUBST(exec_prefix)
@@ -86,8 +87,11 @@
 AC_SUBST(SYSTEM_EMAIL2TRAC_CONF)
 
+dnl ##### Check for presence of initgroups() function
+AC_CHECK_FUNCS([initgroups])
+
 
 AC_OUTPUT(
         Makefile
-	email2trac.py
-	delete_spam.py
-	)
+        email2trac.py
+        delete_spam.py
+)
Index: /trunk/run_email2trac.c
===================================================================
--- /trunk/run_email2trac.c	(revision 573)
+++ /trunk/run_email2trac.c	(revision 574)
@@ -27,4 +27,7 @@
 #
 */
+#include "config.h"
+
+#include <sys/types.h>
 #include <stdlib.h>
 #include <unistd.h>
@@ -34,4 +37,7 @@
 #include <stdio.h>
 #include <limits.h>
+#ifdef HAVE_INITGROUPS
+#include <grp.h>
+#endif
 
 #include "run_email2trac.h"
@@ -107,14 +113,20 @@
   }
   
-  /* set UID/GID to Trac (or apache) user */
+  /* set UID/GID and supplementary groups to be Trac (or apache) user */
   check_username(TRAC_USER);
   if ( TRAC = getpwnam(TRAC_USER) ) {
+#ifdef HAVE_INITGROUPS
+    if (initgroups(TRAC_USER, TRAC->pw_gid)) {
+      if ( DEBUG ) printf("initgroups failed\n");
+      return -7;    /* 249 : Can't set supplementary groups */
+    }
+#endif
     if (setgid(TRAC->pw_gid) || setuid(TRAC->pw_uid)) {
       if ( DEBUG ) printf("setgid or setuid failed\n");
-      return -5;
+      return -5;   /* 251: Can't set gid or uid */
     }
   } else {
     if ( DEBUG ) printf("Invalid Trac user (%s)\n",TRAC_USER);
-    return -3;     /* 253 : Trac user not found */
+    return -6;     /* 250 : Trac user not found */
   }
 	 
